{{
  This object is used to test SpinSim.  It performs console I/O, and opens and reads files.
  Added a "run" command to load a binary Spin file and execute it.
  Added a "dir" command to list the directory
}}
obj
  ser : "conio"
  fs : "fileio"

pub loader | num, dbase, fname, size, vbase
  size := fname := @@0 - 128 - 16
  {
  ser.str(string("loader: "))
  ser.str(fname)
  ser.tx(13)
  }
  ifnot fs.popen(fname, "R")
    num := fs.pread(0, size)
    if num == size
      ser.str(string("File too large", 13))
      return
    dbase := word[10]
    vbase := word[8]
    long[dbase]~
    long[dbase - 4] := $fff9ffff
    long[dbase - 8] := $fff9ffff
    num := dbase - vbase - 8
    if num > 0
      bytefill(vbase, 0, num)
    coginit(cogid, $f004, 4)
  else
    ser.str(string("Could not open "))
    ser.str(fname)
    ser.tx(13)